"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var commands_1 = require("../commands");
var util_1 = require("../util");
var defaultPublishEndpoint = "/usp/endpoint";
var defaultSubscribeEndpoint = "/usp/controller";
var defaultIdEndpoint = "obuspa/EndpointID";
var defaultFromId = "proto::interop-usp-controller";
var defaultConnectionTimeout = 5000;
var defaultIdResolveTimeout = 5000;
var fixId = function (s) { return s.split("+").join("%2B"); };
var wait = function (ms) {
    var waitId;
    var waitPromise = new Promise(function (_, reject) {
        waitId = setTimeout(function () {
            reject("timeout of " + ms + "ms reached");
        }, ms);
    });
    return [waitId, waitPromise];
};
var timeoutWrapper = function (promise, ms) {
    if (typeof ms === "number" && ms >= 0) {
        var _a = wait(ms), waitId_1 = _a[0], waitPromise = _a[1];
        return Promise.race([
            promise().then(function (res) {
                clearTimeout(waitId_1);
                return res;
            }),
            waitPromise,
        ]);
    }
    else
        return promise();
};
var wrap = function (opts, cmdName, cmd) {
    return (function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        // Promise.resolve added to handle non-promise commands
        var cmdCall = function () { return Promise.resolve(cmd.apply(void 0, args)); };
        var finalCall = function () {
            return timeoutWrapper(cmdCall, opts.timeout)
                .then(function (res) {
                opts.postCall && opts.postCall(cmdName, args, res);
                return res;
            })
                .catch(function (err) {
                opts.postCall && opts.postCall(cmdName, args, err);
                throw err;
            });
        };
        if (opts.preCall)
            opts.preCall(cmdName, args);
        return finalCall();
    });
};
var addOptions = function (usp, opts) {
    var mainUSP = Object.entries(usp).reduce(function (acc, _a) {
        var _b;
        var k = _a[0], fn = _a[1];
        return (__assign(__assign({}, acc), (_b = {}, _b[k] = wrap(opts, k, fn), _b)));
    }, {});
    mainUSP.options = function (opts) { return addOptions(mainUSP, opts); };
    return mainUSP;
};
var buildConnect = function (_a) {
    var connectClient = _a.connectClient, decodeID = _a.decodeID, loadProtobuf = _a.loadProtobuf;
    return function (options, events) { return __awaiter(void 0, void 0, void 0, function () {
        var subscribeEndpoint, publishEndpoint, idEndpoint, proto, router, callbackRouter, handleError, handleOffline, handleReconnect, handleClose, connectTimeout, client, handleInit, toId, _a, _b, fromId, reconnectCount, isTrackingReconnects, on, encode, call, baseUSP;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    subscribeEndpoint = options.subscribeEndpoint || defaultSubscribeEndpoint;
                    publishEndpoint = options.publishEndpoint || defaultPublishEndpoint;
                    idEndpoint = options.idEndpoint || defaultIdEndpoint;
                    return [4 /*yield*/, loadProtobuf()];
                case 1:
                    proto = _c.sent();
                    router = util_1.makeRouter();
                    callbackRouter = util_1.makeCallbackRouter();
                    handleError = function (err) {
                        return events && events.onError && events.onError(err);
                    };
                    handleOffline = function () {
                        events && events.onOffline && events.onOffline();
                        client.end();
                    };
                    handleReconnect = function () {
                        return events && events.onReconnect && events.onReconnect();
                    };
                    handleClose = function () { return events && events.onClose && events.onClose(); };
                    callbackRouter.add("error", handleError);
                    connectTimeout = options.connectTimeout || defaultConnectionTimeout;
                    return [4 /*yield*/, timeoutWrapper(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2 /*return*/, connectClient(options)];
                        }); }); }, connectTimeout)];
                case 2:
                    client = _c.sent();
                    handleInit = function () {
                        return new Promise(function (resolve, reject) {
                            var id = setTimeout(function () {
                                return reject({
                                    errMsg: "toId was not received within timeout(" + defaultIdResolveTimeout + "ms)",
                                });
                            }, defaultIdResolveTimeout);
                            client.on("message", function (topic, data) {
                                clearTimeout(id);
                                client.unsubscribe(idEndpoint);
                                resolve(decodeID(data || topic));
                            });
                            client.subscribe(idEndpoint);
                        });
                    };
                    _a = fixId;
                    _b = options.toId;
                    if (_b) return [3 /*break*/, 4];
                    return [4 /*yield*/, handleInit()];
                case 3:
                    _b = (_c.sent());
                    _c.label = 4;
                case 4:
                    toId = _a.apply(void 0, [_b]);
                    fromId = options.fromId || defaultFromId;
                    client.on("message", function (_topic, data) {
                        var parsedMsg = commands_1.readMsg(proto, data || _topic);
                        var _a = commands_1.decode(parsedMsg), id = _a[0], message = _a[1], err = _a[2], cmdType = _a[3];
                        if (typeof id !== "string") {
                            handleError("Could not locate id for message:\n" + JSON.stringify(parsedMsg, null, 2));
                        }
                        else {
                            var call_1 = router.get(id, cmdType || "NOTIFY");
                            if (call_1 && call_1.resolve && call_1.reject) {
                                if (err)
                                    call_1.reject(err);
                                else if (call_1.options) {
                                    var messageAfterOptions = commands_1.decodeWithOptions(parsedMsg, cmdType, call_1.options);
                                    call_1.resolve(messageAfterOptions);
                                }
                                else
                                    call_1.resolve(message);
                            }
                            var cbs = callbackRouter.get(id);
                            cbs.forEach(function (cb) {
                                if (message)
                                    cb(message, parsedMsg);
                                else if (err)
                                    cb(err, parsedMsg);
                            });
                        }
                    });
                    reconnectCount = 0;
                    isTrackingReconnects = typeof options.reconnectsBeforeClosing === "number";
                    client.on("error", function (err) {
                        callbackRouter.get("error").forEach(function (cb) { return cb(err); });
                        handleError(JSON.stringify(err, null, 2));
                    });
                    client.on("offline", handleOffline);
                    client.on("reconnect", function () {
                        handleReconnect();
                        if (isTrackingReconnects)
                            reconnectCount++;
                    });
                    client.on("close", function () {
                        handleClose();
                        if (options.closeOnDisconnect === true)
                            client.end();
                        if (isTrackingReconnects &&
                            reconnectCount >= options.reconnectsBeforeClosing)
                            client.end();
                    });
                    on = function (ident, callback) {
                        callbackRouter.add(ident, callback);
                        return function () {
                            callbackRouter.del(ident);
                        };
                    };
                    encode = commands_1.makeEncode(proto, { fromId: fromId, toId: toId });
                    call = function (command, args, callOpts) {
                        return new Promise(function (resolve, reject) {
                            var _a = encode(command, args), id = _a[0], msg = _a[1], err = _a[2];
                            if (err)
                                reject(err);
                            else {
                                router.add(id, (callOpts === null || callOpts === void 0 ? void 0 : callOpts.responseMsgType) || command, {
                                    resolve: resolve,
                                    reject: reject,
                                    options: args.options,
                                });
                                client.publish(publishEndpoint, msg);
                            }
                        });
                    };
                    return [4 /*yield*/, client.subscribe(subscribeEndpoint)];
                case 5:
                    _c.sent();
                    baseUSP = __assign(__assign({ get: function (paths, options) { return call("GET", { paths: paths, options: options }); }, set: function (path, value) { return call("SET", { path: path, value: value }); }, add: function (path, value) { return call("ADD", { path: path, value: value }); }, del: function (paths, allowPartial) { return call("DELETE", { paths: paths, allowPartial: allowPartial }); }, instances: function (paths, opts) { return call("GET_INSTANCES", { paths: paths, opts: opts }); }, supportedDM: function (paths, opts) { return call("GET_SUPPORTED_DM", { paths: paths, opts: opts }); }, supportedProto: function (versions) { return call("GET_SUPPORTED_PROTO", { versions: versions }); }, _operate: function (path, id, resp, input) {
                            return call("OPERATE", { path: path, input: input, id: id, resp: resp });
                        }, on: on }, commands_1.makeRecipes(call, on)), { disconnect: function () { return client.end(); } });
                    return [2 /*return*/, __assign(__assign({}, baseUSP), { options: function (opts) { return addOptions(baseUSP, opts); } })];
            }
        });
    }); };
};
exports.default = buildConnect;
