import * as util from "./util.js";
const decode = (msg) => {
const resolvedPathResultsArr = util.searchAll(msg, "resolvedPathResults");
const requestedPath = util.search(msg, "requestedPath");
if (resolvedPathResultsArr) {
const pathIncludesSearch = typeof requestedPath === "string" &&
(requestedPath.includes("*") || requestedPath.includes("["));
const pathSplit = requestedPath.split(".");
const hasMultipleIndexes = util.hasMultipleIndexes(resolvedPathResultsArr
.map((it) => Object.keys(it.resultParams).map((p) => it.resolvedPath + p))
.flat(1), pathSplit);
const shouldBeArray = pathIncludesSearch || hasMultipleIndexes;
const unflattened = util.convertToNestedObject(resolvedPathResultsArr);
const unwrapped = util.fullyUnwrapObject(unflattened, shouldBeArray);
return [unwrapped];
}
return [null];
};
const encode = ({ paths }) => ({
lookup: "Msg",
header: {
msgId: util.uniq("GET@"),
msgType: "GET",
lookup: "Header",
},
body: {
lookup: "Body",
request: {
lookup: "Request",
get: {
paramPaths: Array.isArray(paths) ? paths : [paths],
},
},
},
});
export default {
decode,
encode,
};
