import { uniq } from "../util.js";
const operateSubscriptionPath = "Device.LocalAgent.Subscription.";
const make = (call, on) => async (path, opts) => {
const Persistent = opts?.Persistent === undefined ? false : opts.Persistent;
const id = "NOTIFY@" + (opts?.ID || uniq(path));
const operateInput = {
Enable: true,
ID: id,
NotifType: "OperationComplete",
ReferenceList: path,
Persistent,
};
const newSubPath = await call("ADD", {
path: operateSubscriptionPath,
value: operateInput,
});
const command = (input) => {
return call("OPERATE", {
path,
input,
id,
resp: opts?.sendResponse ?? true,
}, opts && opts.isAsync === false ? {} : { responseMsgType: "NOTIFY" });
};
command.subscribe = (cb, opts) => {
const skipOperateResponse = opts?.skipOperateResponse ?? true;
const handleCallback = (msg) => {
if (skipOperateResponse &&
typeof msg === "object" &&
"executedCommand" in msg)
return;
else
cb(msg);
};
on(id, handleCallback);
return {
trigger: command,
};
};
const cleanup = () => call("DELETE", { paths: newSubPath });
return [command, cleanup];
};
export default {
name: "operate",
make,
};
